#version 330 compatibility

#include "../sampleFetch.glsl"
#include "const.glsl"

uniform sampler2D textureMap;
uniform sampler2D normalIDMap;
uniform sampler2D mvPosMap;
uniform float radius;
uniform int steps;
uniform float threshold_depth;
uniform float threshold_normal;




void main (void) {

	vec4 normalID = texture2D(normalIDMap, gl_TexCoord[0].st);
	vec4 mvpos = texture2D(mvPosMap, gl_TexCoord[0].st);
	
	if(normalID.w < 0.5){
		gl_FragColor = vec4(1.0);
		return;	
	}
		
	
   
   
    vec4 sum = vec4(0);
  	float sumWeight = 0;
	int lowpos = int(-steps/2);
	
    for(int i = 0; i <  steps;++i ){
 
			int p = i + lowpos;
			ivec2 cordinate = ivec2(gl_FragCoord.x, gl_FragCoord.y + p);
			
			vec4 pos = texelFetch(mvPosMap, cordinate, 0);  //depth
			vec4 normal = texelFetch(normalIDMap, cordinate, 0);  //normal
			
			if( length(mvpos - pos) < threshold_depth && dot(normal.xyz,normalID.xyz) > threshold_normal){
				vec4 tex = texelFetch(textureMap,cordinate, 0);
				sum += tex;
				sumWeight++;
			}
     
     }
     
    

    sum /= sumWeight;
   
    gl_FragColor = vec4(sum);
  
  
}

